// 0:Line　1:Dot 2:Line and Dot
let dotMode = "2";
let map;
let infoWindow;
let marker;
const dotMarker = [];
const dotMarkers = [[]];
let dataIdx = 0;
let geoJsons = ['json/'+getParam('json')+'.json'];

let dataSize = 0;
$(function () {

    const apiKey = counter();
    $.ajax({
        type    : 'GET',
        url     : "http://maps.googleapis.com/maps/api/js?key=",
        data    : {
            key  : apiKey
        },
        dataType: 'script',
        jsonp   : 'callback'
    }).done( () => {
        // 初期設定
        map = new google.maps.Map(document.getElementById('map'), {
            zoom: 13,
            mapTypeControlOptions: {
                style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
                // position: google.maps.ControlPosition.TOP_LEFT
            },
            fullscreenControlOptions: {
                position: google.maps.ControlPosition.BOTTOM_RIGHT
            },
            zoomControlOptions: {
                // position: google.maps.ControlPosition.LEFT_TOP
            },
            streetViewControlOptions: {
                // position: google.maps.ControlPosition.LEFT_TOP
            }
        });

        infoWindow = new google.maps.InfoWindow({
            maxWidth: 250
        });
        marker = new google.maps.Marker();
        var copyrightNode = document.createElement('div');
        copyrightNode.innerHTML = "<a target='_blank' href='http://willgps.com'><img hspace='15' vspace='15' width='300' src='http://img.cloudgps.net/geojson/img/willgps_300.gif' /></a>";
        map.controls[google.maps.ControlPosition.TOP_RIGHT].push(copyrightNode);

        // 通常処理
        geoJsons.forEach(geoJson => {
            map.data.loadGeoJson(geoJson);
        });

        map.data.setStyle(function(feature) {
            return {
                fillColor: feature.getProperty('color'),
                strokeColor: feature.getProperty('color'),
                strokeOpacity: 0.8,
                strokeWeight: 4,
            };
        });

        // ドットモード追加
        map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push(document.getElementById("dotMode"))

        addListener();

        google.maps.event.addListener(map.data,'addfeature', function(e){
            const data = e.feature.getGeometry().getArray();
            e.feature.setProperty("data",data);
            const latLng = new google.maps.LatLng(data[0].lat(), data[0].lng());
            map.setCenter(latLng);

            const assetId = e.feature.getProperty('assetId');
            const speed = e.feature.getProperty('speed');

            $(".assetId").text(assetId)
            $(".positionTime").text(e.feature.getProperty('time')[0])
            $(".eventTitle").text(e.feature.getProperty('event')[0])
            $("#addressText a").text(e.feature.getProperty('address')[0])
            $(".rt.eventIcon").removeClass().addClass("rt eventIcon").addClass(e.feature.getProperty('eventIcon')[0])
            $(".stoppingTime").html('<span class="rt r-delivery"></span>' + e.feature.getProperty('stoppingTime')[0])
            $(".battery").text(e.feature.getProperty('battery')[0])
            $(".speed").text(speed[0])
            $(".accuracy").text(e.feature.getProperty('accuracy')[0])
            $("#latitude").val(data[0].lat());
            $("#longitude").val(data[0].lng());

            const content = document.getElementById("infoWindow");
            content.style.display = "inherit"
            infoWindow.setContent(content);
            infoWindow.setPosition(latLng);
            infoWindow.open(map, marker);
            setMarker(latLng, map, marker);

            dataSize = data.length - 1;
            $(".infoNo.currentNo").text(1);
            $(".infoNo.maxNo").text(dataSize+1);

            const logs = [];
            let i = 0;
            data.forEach(d => {
                logs.push( {
                    latitude: d.lat(),
                    longitude: d.lng(),
                    speed: speed[i]
                })
                i++;
            });
            drawDot(logs, assetId, assetId, geoJsons.length > 1 ? true : false);
        });

        addListenerForDot();


        infoWindow.addListener("closeclick", function () {
            const infoWindowContent = infoWindow.getContent();
            infoWindowContent.style.display = "none";
            $("#infoWindowArea").html(infoWindowContent);
        });

        marker.addListener('click', function() {
            const content = document.getElementById("infoWindow");
            content.style.display = "inherit"
            infoWindow.setContent(content);
            infoWindow.open(map, marker);
        });

        $(".first").on("click", function () {
            dataIdx = 0;
            moving(dataIdx, dataSize);
        });

        $(".prev").on("click", function () {
            if (dataIdx == 0) return;
            dataIdx--;
            moving(dataIdx, dataSize);
        });

        $(".next").on("click", function () {
            if (dataIdx == dataSize) return;
            dataIdx++;
            moving(dataIdx, dataSize);
        });

        $(".last").on("click", function () {
            dataIdx = 4;
            moving(dataIdx, dataSize);
        });
    });

})

let listener;
function addListener() {
    listener = google.maps.event.addListener(map.data, 'click', (event) => {
        const location = {
            latitude: event.latLng.lat(),
            longitude: event.latLng.lng()
        }
        let index = 0
        const data = [];
        event.feature.getProperty('data').forEach(d => {
            data.push({
                idx: index,
                latitude: d.lat(),
                longitude: d.lng()
            });
            index++;
        });
        const log = getNearlyGPSLog(data, location);
        const idx = log.idx;
        dataIdx = idx;

        $(".assetId").text(event.feature.getProperty('assetId'))
        $(".positionTime").text(event.feature.getProperty('time')[idx])
        $(".eventTitle").text(event.feature.getProperty('event')[idx])
        $("#addressText a").text(event.feature.getProperty('address')[idx])
        $(".rt.eventIcon").removeClass().addClass("rt eventIcon").addClass(event.feature.getProperty('eventIcon')[idx])
        $(".stoppingTime").html('<span class="rt r-delivery"></span>' + event.feature.getProperty('stoppingTime')[idx])
        $(".battery").text(event.feature.getProperty('battery')[idx])
        $(".speed").text(event.feature.getProperty('speed')[idx])
        $(".accuracy").text(event.feature.getProperty('accuracy')[idx])
        $("#latitude").val(event.latLng.lat());
        $("#longitude").val(event.latLng.lng());

        const lat = event.feature.getProperty('data')[idx].lat();
        const lng = event.feature.getProperty('data')[idx].lng();
        const latLng = new google.maps.LatLng(lat, lng);
        const content = document.getElementById("infoWindow");
        content.style.display = "inherit";
        infoWindow.setContent(content);
        infoWindow.setPosition(latLng);
        infoWindow.open(map, marker);

        $(".infoNo.currentNo").text(idx+1);
        $(".infoNo.maxNo").text(dataSize+1);

        setMarker(latLng, map, marker)
    });
}

function removeListener() {
    google.maps.event.removeListener(listener)
}

let clickDotMarker = []
function addListenerForDot () {
    if (dotMarker && dotMarker.length > 0) {
        dotMarker.forEach(mk => {
            const click = google.maps.event.addListener( mk, "click", function( event ) {
                const location = {
                    latitude: event.latLng.lat(),
                    longitude: event.latLng.lng()
                }
                const data = [];
                let assetId = "";
                let index = 0;
                let hitIdx = 0;
                map.data.forEach(d => {
                    d.getGeometry().getArray().forEach(array => {
                        data.push({
                            idx: index,
                            latitude: array.lat(),
                            longitude: array.lng()
                        });
                        index++;
                        if (location.latitude == array.lat() && location.longitude == array.lng()) {
                            assetId = d.getProperty("assetId");
                            hitIdx = index;
                            return;
                        }
                    })
                });
                const log = getNearlyGPSLog(data, location);
                const idx = log.idx;
                dataIdx = idx;
                localStorage.removeItem(assetId)
                map.data.forEach(d => {

                    const len = d.getProperty("time").length;
                    const flg = localStorage.getItem(assetId);
                    if (assetId != d.getProperty("assetId") || flg == "true") {
                        return;
                    }

                    $(".assetId").text(assetId)
                    $(".positionTime").text(d.getProperty('time')[idx-len >= 0 ? idx-len : idx])
                    $(".eventTitle").text(d.getProperty('event')[idx-len >= 0 ? idx-len : idx])
                    $("#addressText a").text(d.getProperty('address')[idx-len >= 0 ? idx-len : idx])
                    $(".rt.eventIcon").removeClass().addClass("rt eventIcon").addClass(d.getProperty('eventIcon')[idx-len >= 0 ? idx-len : idx])
                    $(".stoppingTime").html('<span class="rt r-delivery"></span>' + d.getProperty('stoppingTime')[idx-len >= 0 ? idx-len : idx])
                    $(".battery").text(d.getProperty('battery')[idx-len >= 0 ? idx-len : idx])
                    $(".speed").text(d.getProperty('speed')[idx-len >= 0 ? idx-len : idx])
                    $(".accuracy").text(d.getProperty('accuracy')[idx-len >= 0 ? idx-len : idx])
                    $("#latitude").val(event.latLng.lat());
                    $("#longitude").val(event.latLng.lng());

                    const lat = event.latLng.lat();
                    const lng = event.latLng.lng();
                    const latLng = new google.maps.LatLng(lat, lng);
                    const content = document.getElementById("infoWindow");
                    content.style.display = "inherit";
                    infoWindow.setContent(content);
                    infoWindow.setPosition(latLng);
                    infoWindow.open(map, marker);

                    $(".infoNo.currentNo").text(idx-len >= 0 ? idx-len+1 : idx+1);
                    $(".infoNo.maxNo").text(dataSize+1);

                    setMarker(latLng, map, marker);

                    localStorage.setItem(assetId, "true")
                });
            })
            clickDotMarker.push(click)
        })
    }

    if (dotMarkers && dotMarkers.length > 0) {
        dotMarkers.forEach(marker_ => {
            marker_.forEach(mk => {
                const click = google.maps.event.addListener( mk, "click", function( event ) {
                    const location = {
                        latitude: event.latLng.lat(),
                        longitude: event.latLng.lng()
                    }
                    const data = [];
                    let assetId = "";
                    let index = 0;
                    let hitIdx = 0;
                    map.data.forEach(d => {
                        d.getGeometry().getArray().forEach(array => {
                            data.push({
                                idx: index,
                                latitude: array.lat(),
                                longitude: array.lng()
                            });
                            index++;
                            if (location.latitude == array.lat() && location.longitude == array.lng()) {
                                assetId = d.getProperty("assetId");
                                hitIdx = index;
                                return;
                            }
                        })
                    });
                    const log = getNearlyGPSLog(data, location);
                    const idx = log.idx;
                    dataIdx = idx;
                    localStorage.removeItem(assetId)
                    map.data.forEach(d => {

                        const len = d.getProperty("time").length;
                        const flg = localStorage.getItem(assetId);
                        if (assetId != d.getProperty("assetId") || flg == "true") {
                            return;
                        }

                        $(".assetId").text(assetId)
                        $(".positionTime").text(d.getProperty('time')[idx-len >= 0 ? idx-len : idx])
                        $(".eventTitle").text(d.getProperty('event')[idx-len >= 0 ? idx-len : idx])
                        $("#addressText a").text(d.getProperty('address')[idx-len >= 0 ? idx-len : idx])
                        $(".rt.eventIcon").removeClass().addClass("rt eventIcon").addClass(d.getProperty('eventIcon')[idx-len >= 0 ? idx-len : idx])
                        $(".stoppingTime").html('<span class="rt r-delivery"></span>' + d.getProperty('stoppingTime')[idx-len >= 0 ? idx-len : idx])
                        $(".battery").text(d.getProperty('battery')[idx-len >= 0 ? idx-len : idx])
                        $(".speed").text(d.getProperty('speed')[idx-len >= 0 ? idx-len : idx])
                        $(".accuracy").text(d.getProperty('accuracy')[idx-len >= 0 ? idx-len : idx])
                        $("#latitude").val(event.latLng.lat());
                        $("#longitude").val(event.latLng.lng());

                        const lat = event.latLng.lat();
                        const lng = event.latLng.lng();
                        const latLng = new google.maps.LatLng(lat, lng);
                        const content = document.getElementById("infoWindow");
                        content.style.display = "inherit";
                        infoWindow.setContent(content);
                        infoWindow.setPosition(latLng);
                        infoWindow.open(map, marker);

                        $(".infoNo.currentNo").text(idx-len >= 0 ? idx-len+1 : idx+1);
                        $(".infoNo.maxNo").text(dataSize+1);

                        setMarker(latLng, map, marker);

                        localStorage.setItem(assetId, "true")
                    });

                })
                clickDotMarker.push(click)
            })

        })
    }
}
function removeListenerForDot () {
    if (clickDotMarker && clickDotMarker.length > 0) {
        clickDotMarker.forEach(marker => {
            google.maps.event.removeListener( marker);
        })
    }

}

moving = (dataIdx, dataSize) => {

    const assetId = $(".assetId").text();

    map.data.forEach(function (feature) {

        if (assetId != feature.getProperty('assetId'))  return;

        $(".assetId").text(feature.getProperty('assetId'))
        $(".positionTime").text(feature.getProperty('time')[dataIdx])
        $(".eventTitle").text(feature.getProperty('event')[dataIdx])
        $("#addressText a").text(feature.getProperty('address')[dataIdx])
        $(".rt.eventIcon").removeClass().addClass("rt eventIcon").addClass(feature.getProperty('eventIcon')[dataIdx])
        $(".stoppingTime").html('<span class="rt r-delivery"></span>' + feature.getProperty('stoppingTime')[dataIdx])
        $(".battery").text(feature.getProperty('battery')[dataIdx])
        $(".speed").text(feature.getProperty('speed')[dataIdx])
        $(".accuracy").text(feature.getProperty('accuracy')[dataIdx])

        const lat = feature.getProperty('data')[dataIdx].lat();
        const lng = feature.getProperty('data')[dataIdx].lng();
        const latLng = new google.maps.LatLng(lat, lng);
        const content = document.getElementById("infoWindow");
        content.style.display = "inherit"
        infoWindow.setContent(content);
        infoWindow.setPosition(latLng);
        infoWindow.open(map, marker);

        $(".infoNo.currentNo").text(dataIdx+1);
        $(".infoNo.maxNo").text(dataSize+1);

        setMarker(latLng, map, marker);
    });
}

function setMarker(latlng, map, marker){

    marker.setMap(map)
    marker.setPosition(latlng)
    marker.setVisible(true);
    const iconOptions = {
        url: "http://img.cloudgps.net/geojson/img/maps-and-flags-l.png",
        labelOrigin: new google.maps.Point(0, 0),
        origin: new google.maps.Point(0, 0),
        scaledSize: new google.maps.Size(30, 30),
        size: new google.maps.Size(30, 30)
    }
    marker.setIcon(iconOptions)
    marker.addListener('click', function() { // マーカーをクリックしたとき
    });
}

function getNearlyGPSLog(data, location){
    return data.sort( function (l1, l2) {
        const d1 = geolib.getDistance( location, l1 )
        const d2 = geolib.getDistance( location, l2 )
        if (d1 > d2)       { return 1; }
        else if (d1 == d2) { return 0; }
        else               { return -1; }
    })[0]
}

showStreetView = () => {
    if (map) {
        const streetViewPanorama = map.getStreetView();
        const latitude = $("#latitude").val();
        const longitude = $("#longitude").val();
        streetViewPanorama.setPosition(new google.maps.LatLng(latitude, longitude));
        streetViewPanorama.setPov(({
            heading: 265,
            pitch: 0
        }));
        const toggle = streetViewPanorama.getVisible();
        if (toggle == false) {
            streetViewPanorama.setVisible(true);
        }
        else {
            streetViewPanorama.setVisible(false);
        }
    }
}

doDotMode = () => {
    dotMode = "0"

    map.data.setStyle(function(feature) {
        return {
            fillColor: feature.getProperty('color'),
            strokeColor: feature.getProperty('color'),
            strokeOpacity: 0,
            strokeWeight: 4,
        };
    });
    removeListener();
    // ドットを表示
    if (dotMarker && dotMarker.length > 0) {
        dotMarker.forEach(marker => {
            marker.setVisible(true)
        })
    }
    // ドットを表示(複数)
    if (dotMarkers && dotMarkers.length > 0) {
        dotMarkers.forEach(marker => {
            marker.forEach(mk => {
                mk.setVisible(true)
            })
        })
    }
    addListenerForDot();
}

doLineMode = () => {

    dotMode = "2";

    // ドットを消去
    if (dotMarker && dotMarker.length > 0) {
        dotMarker.forEach(marker => {
            marker.setVisible(false)
        })
    }
    // ドットを消去(複数)
    if (dotMarkers && dotMarkers.length > 0) {
        dotMarkers.forEach(marker => {
            marker.forEach(mk => {
                mk.setVisible(false)
            })
        })
    }
    removeListenerForDot();
    map.data.setStyle(function(feature) {
        return {
            fillColor: feature.getProperty('color'),
            strokeColor: feature.getProperty('color'),
            strokeOpacity: 0.8,
            strokeWeight: 4,
        };
    });
    addListener();
}

doDotLineMode = () => {
    dotMode = "1";
    map.data.setStyle(function(feature) {
        return {
            fillColor: feature.getProperty('color'),
            strokeColor: feature.getProperty('color'),
            strokeOpacity: 0.8,
            strokeWeight: 4,
        };
    });

    addListener();
    // ドットを表示
    if (dotMarker && dotMarker.length > 0) {
        dotMarker.forEach(marker => {
            marker.setVisible(true)
        })
    }
    // ドットを表示(複数)
    if (dotMarkers && dotMarkers.length > 0) {
        dotMarkers.forEach(marker => {
            marker.forEach(mk => {
                mk.setVisible(true)
            })
        })
    }

    addListenerForDot();
}

function drawDot ( logs, assetId, assetName, multiple )  {
    // ドットを描画
    if (multiple) {
        const mker = []
        logs.forEach((gpsLog, index) => {
            if (!map) return

            const marker = new google.maps.Marker()
            marker.setPosition(new google.maps.LatLng(gpsLog.latitude, gpsLog.longitude))
            marker.setVisible(false)
            marker.setMap(map)
            const iconOptions = {
                labelOrigin: new google.maps.Point(0, 0),
                origin: new google.maps.Point(0, 0),
                // scaledSize: new google.maps.Size(10, 10),
                // size: new google.maps.Size(10, 10),
                // anchor: new google.maps.Point(5, 5)
            }

            if (index == 0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/start.png"
                // iconOptions['scaledSize'] = new google.maps.Size(32, 32)
                iconOptions['size'] = new google.maps.Size(32, 32)
            } else if (index == logs.length - 1) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/end.png"
                // iconOptions['scaledSize'] = new google.maps.Size(32, 32)
                iconOptions['size'] = new google.maps.Size(32, 32)
            } else if (gpsLog.speed >= 0 && gpsLog.speed <= 3.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/bluedot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else if (gpsLog.speed > 3.0 && gpsLog.speed <= 10.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/greendot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else if (gpsLog.speed > 10.0 && gpsLog.speed <= 30.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/reddot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/pinkdot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            }

            marker.set("assetId", assetId)
            marker.set("assetName", assetName)
            marker.setIcon(iconOptions)
            mker.push(marker)
        })
        dotMarkers.push(mker)
    } else {

        logs.forEach((gpsLog, index) => {
            if (!map) return

            var marker = new google.maps.Marker()
            marker.setPosition(new google.maps.LatLng(gpsLog.latitude, gpsLog.longitude))
            marker.setVisible(false)
            marker.setMap(map)
            var iconOptions = {
                labelOrigin: new google.maps.Point(0, 0),
                origin: new google.maps.Point(0, 0),
                // scaledSize: new google.maps.Size(10, 10),
                // size: new google.maps.Size(10, 10),
                // anchor: new google.maps.Point(5, 5)
            }

            if (index == 0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/start.png"
                // iconOptions['scaledSize'] = new google.maps.Size(32, 32)
                iconOptions['size'] = new google.maps.Size(32, 32)
            } else if (index == logs.length - 1) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/end.png"
                // iconOptions['scaledSize'] = new google.maps.Size(32, 32)
                iconOptions['size'] = new google.maps.Size(32, 32)
            } else if (gpsLog.speed >= 0 && gpsLog.speed <= 3.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/bluedot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else if (gpsLog.speed > 3.0 && gpsLog.speed <= 10.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/greendot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else if (gpsLog.speed > 10.0 && gpsLog.speed <= 30.0) {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/reddot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            } else {
                iconOptions['url'] = "http://img.cloudgps.net/geojson/img/pinkdot.png"
                iconOptions['scaledSize'] = new google.maps.Size(10, 10)
                iconOptions['anchor'] = new google.maps.Point(5, 5)
                iconOptions['size'] = new google.maps.Size(16, 16)
            }

            marker.set("assetId", assetId)
            marker.set("assetName", assetName)
            marker.setIcon(iconOptions)
            dotMarker.push(marker)
        })
    }
}

function onDotModeClick () {
    switch (dotMode) {
        case "0":
            doLineMode()
            $("#dotMode img").attr("src", "http://img.cloudgps.net/geojson/img/m2.png")
            break;
        case "2":
            doDotLineMode()
            $("#dotMode img").attr("src", "http://img.cloudgps.net/geojson/img/m3.png")
            break;
        case "1":
            doDotMode()
            $("#dotMode img").attr("src", "http://img.cloudgps.net/geojson/img/m1.png")
            break;
    }
}

/**
 * Get the URL parameter value
 *
 * @param  name {string} パラメータのキー文字列
 * @return  url {url} 対象のURL文字列（任意）
 */
function getParam(name, url) {
    if (!url) url = window.location.href;
    name = name.replace(/[¥[¥]]/g, "¥¥$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/¥+/g, " "));
}
